---
title: Xamarin.Android error XA0003
description: XA0003 error code
ms.date: 07/13/2019
---
# Xamarin.Android error XA0003

## Issue

This error means the value for `android:versionCode` in the 
`AndroidManifest.xml` file is not an integer value. 

Google requires that the value be an integer within the 
range of 0 to 2100000000. 
See [https://developer.android.com/studio/publish/versioning](https://developer.android.com/studio/publish/versioning)
for more details.

## Solution

Correct the `android:versionCode` in the `AndroidManifest.xml` to 
be an integer in the range of 0 to 2100000000.